-- ExternalAccount.lua
-- author: rafftnix
-- date: 18.11.2012

-- Thanks to FIAT80-90 DT for this stunning HUD design

-- Keine Vernderung ohne meine Erlaubnis!
-- No modification without my permission!
-- history: 
--  		v1.0 (November 2012)

ExternalAccount = {}
ExternalAccount.modDir = g_currentModDirectory;

function ExternalAccount:loadMap(name)	
	g_currentMission.externalAccount = {}
	g_currentMission.externalAccount.isHUDActive = false;
	g_currentMission.externalAccount.money = 0;
	
	self.amount = 5000;
	self.amount2 = 100;
	
	self.addToSavegame = self.amount;
	self.addToExternalAccount = self.amount;
	
	self.HUD = {}
	self.HUD.background = createImageOverlay(ExternalAccount.modDir.."background.dds");
	self.HUD.minus = createImageOverlay(ExternalAccount.modDir.."icn_minus.dds");
	self.HUD.plus = createImageOverlay(ExternalAccount.modDir.."icn_plus.dds");
	self.HUD.transfer = createImageOverlay(ExternalAccount.modDir.."icn_transfer.dds");
	
	self.warningTime = 3600;
	self.clientNeedsMoneyPermissionWarning = 0;
	
	local savegame = g_currentMission.missionInfo.savegameIndex;
	local dir = getUserProfileAppPath();
	self.filename = dir.."/externalAccount.xml"; 
	self.fileFound = false;
	
	getFiles(dir, "getFilesCallback", self);
	
	if self.fileFound then
		local xml = loadXMLFile("externalAccount", self.filename);
		g_currentMission.externalAccount.money = Utils.getNoNil(getXMLFloat(xml, "externalAccount.money"), 0);
		delete(xml);
	end;	
	
	self.clientNeedsMoneyWarning = InputBinding.hasEvent(InputBinding.TOGGLE_ADMIN);  
	
	local tip = g_currentMission:addHelpButtonText(string.format(g_i18n:getText("tip")), InputBinding.EXTERNALACCOUNTKEY, nil, GS_PRIO_NORMAL);
	self.tip = g_currentMission:addHelpButtonText(string.format(g_i18n:getText("tip2")), InputBinding.EXTERNALACCOUNTHUD, nil, GS_PRIO_NORMAL);
end;

function ExternalAccount:getFilesCallback(filename)
	if filename == "externalAccount.xml" then
		self.fileFound = true;
	end;
end;

function ExternalAccount:deleteMap()
	self:saveMoney();
end;

function ExternalAccount:saveMoney()
	local xml = createXMLFile("externalAccount", self.filename, "externalAccount");
	setXMLFloat(xml, "externalAccount.money", g_currentMission.externalAccount.money);
	saveXMLFile(xml);
	delete(xml);
end;

function ExternalAccount:mouseEvent(posX, posY, isDown, isUp, button)
	if g_currentMission.externalAccount.isHUDActive then
		if isUp then
			-- back button
			if posX > 0.97 and posX < 1 and posY > 0.95 and posY < 1 then
				self:leaveMenu();
			end;
			
			-- add to savegame
			if posX > 0.70 and posX < 0.725 and posY > 0.77 and posY < 0.795 then
				self.addToSavegame = math.max(self.addToSavegame - self.amount, 0);
			end;
			if posX > 0.73 and posX < 0.75 and posY > 0.77 and posY < 0.795 then
				self.addToSavegame = math.min(self.addToSavegame + self.amount, g_currentMission.externalAccount.money);
			end;
			if posX > 0.76 and posX < 0.79 and posY > 0.77 and posY < 0.795 then
				if g_server ~= nil or g_currentMission.clientPermissionSettings.ownMoney then
					self:addMoneyToSavegame(self.addToSavegame);
					self:addMoneyToExternalAccount(-self.addToSavegame);
				else
					self.clientNeedsMoneyPermissionWarning = self.warningTime;
				end;
			end;
			
			-- add to external account
			if posX > 0.70 and posX < 0.725 and posY > 0.74 and posY < 0.765 then
				self.addToExternalAccount = math.max(self.addToExternalAccount - self.amount, 0);
			end;
			if posX > 0.73 and posX < 0.75 and posY > 0.74 and posY < 0.765 then
				self.addToExternalAccount = math.min(self.addToExternalAccount + self.amount, g_currentMission.missionStats.money);
			end;
			if posX > 0.76 and posX < 0.79 and posY > 0.74 and posY < 0.765 then
				self:addMoneyToExternalAccount(self.addToExternalAccount);
				self:addMoneyToSavegame(-self.addToExternalAccount);
			end;
			
			-- MP
			
			local y = 0.65;
			if g_currentMission.users[2] ~= nil then
				local y = 0.62;
				for a=1, table.getn(g_currentMission.users) do
					local user = g_currentMission.users[a];
					if user.userId ~= g_currentMission.playerUserId and (g_server == nil or user.state == 3) then 
						if user.addToExternalAcc == nil then
							user.addToExternalAcc = self.amount2;
						end;
						local size = 0.025;
						if posY > y and posY < (y + 0.03) then
							if posX > 0.70 and posX < 0.725 then
								user.addToExternalAcc = math.max(user.addToExternalAcc - self.amount2, 0);
							end;
							
							if posX > 0.73 and posX < 0.75 then
								user.addToExternalAcc = math.min(user.addToExternalAcc + self.amount2, g_currentMission.externalAccount.money);
							end;
							
							if posX > 0.76 and posX < 0.79 then
								self:sendMoneyTo(a);
							end;
						end;
						y = y - 0.03;
					end;
				end;
			end;
		end;
	end;
end;

function ExternalAccount:addMoneyToSavegame(money)
	if g_server == nil then
		ClientMoneyActionEvent.sendEvent(g_currentMission.playerUserId, money);
	else
		g_currentMission.missionStats.money = g_currentMission.missionStats.money + money;
	end;
end;

function ExternalAccount:addMoneyToExternalAccount(money)
	g_currentMission.externalAccount.money = g_currentMission.externalAccount.money + money;
end;

function ExternalAccount:sendMoneyTo(index)
	local user = g_currentMission.users[index];
	local moneyToSend = user.addToExternalAcc;
	ExternalAccountEvent.sendEvent(self, user.userId, moneyToSend);
	g_currentMission.externalAccount.money = g_currentMission.externalAccount.money - moneyToSend;
end;

function ExternalAccount:keyEvent(unicode, sym, modifier, isDown)

end;

function ExternalAccount:update(dt)
	if InputBinding.isPressed(InputBinding.EXTERNALACCOUNTKEY) then
		if InputBinding.hasEvent(InputBinding.EXTERNALACCOUNTHUD) then
			self:enterMenu();
		end;
	end;
	if g_currentMission.externalAccount.isHUDActive then
		self.addToExternalAccount = math.max(0, math.min(self.addToExternalAccount, g_currentMission.missionStats.money));
		self.addToSavegame = math.max(0, math.min(self.addToSavegame, g_currentMission.externalAccount.money));
		if self.clientNeedsMoneyPermissionWarning > 0 then
			self.clientNeedsMoneyPermissionWarning = math.max(self.clientNeedsMoneyPermissionWarning - dt, 0);
		end;
	end;
end;

function ExternalAccount:draw()
	if not self.fileFound then
		renderText(0.01, 0.01, 0.03, "error"); 
	end;

	if g_currentMission.externalAccount.isHUDActive then
	
		renderOverlay(self.HUD.background, 0, 0, 1, 1);
		
		setTextColor(0.29, 0.44, 0.04, 1);
		
		-- headline
		setTextAlignment(RenderText.ALIGN_CENTER);
		setTextBold(true);
		renderText(0.50, 0.95, 0.04, "welcome");
		setTextBold(false);
		setTextAlignment(RenderText.ALIGN_LEFT);
		
		-- info
		local y = 0.86;
		renderText(0.05, y, 0.03, "moneyOnAccount");
		renderText(0.50, y, 0.03, tostring(math.floor(g_currentMission.externalAccount.money)).."dollar");
		renderText(0.05, y-0.03, 0.03, "moneyOnSavegame");
		renderText(0.50, y-0.03, 0.03, tostring(math.floor(g_currentMission.missionStats.money)).."dollar");
		
		-- add money to savegame
		local y = 0.77;
		local size = 0.025;
		renderText(0.05, y, size, g_i18n:getText("addMoneyToSavegame"));
		renderText(0.50, y, size, string.format(g_i18n:getText("amount"), self.addToSavegame));

		renderOverlay(self.HUD.minus, 0.70, y, 0.025, 0.025);
		renderOverlay(self.HUD.plus, 0.73, y, 0.025, 0.025);
		renderOverlay(self.HUD.transfer, 0.76, y, 0.025, 0.025);

		-- add money to account
		local y = 0.74;
		local size = 0.025;
		renderText(0.05, y, size, g_i18n:getText("addMoneyToAccount"));
		renderText(0.50, y, size, string.format(g_i18n:getText("amount"), self.addToExternalAccount));
		
		renderOverlay(self.HUD.minus, 0.70, y, 0.025, 0.025);
		renderOverlay(self.HUD.plus, 0.73, y, 0.025, 0.025);
		renderOverlay(self.HUD.transfer, 0.76, y, 0.025, 0.025);
		
		-- MP 
		local y = 0.65;
		renderText(0.05, y, 0.04, g_i18n:getText("transferMoneyToOtherPlayers"));
		if g_currentMission.users[2] == nil then
			renderText(0.05, y-0.07, size, g_i18n:getText("onlyForMultiplayer"));
		else
			local y = 0.62;
			for a=1, table.getn(g_currentMission.users) do
				local user = g_currentMission.users[a];
				if user.userId ~= g_currentMission.playerUserId and (g_server == nil or user.state == 3) then 
					if user.addToExternalAcc == nil then
						user.addToExternalAcc = self.amount;
					end;
					user.addToExternalAcc = math.min(user.addToExternalAcc, g_currentMission.externalAccount.money);
					
					local size = 0.025;
					renderText(0.05, y, 0.025, user.nickname);
					renderText(0.50, y, size, string.format(g_i18n:getText("amount"), user.addToExternalAcc));
		
					renderOverlay(self.HUD.minus, 0.70, y, 0.025, 0.025);
					renderOverlay(self.HUD.plus, 0.73, y, 0.025, 0.025);
					renderOverlay(self.HUD.transfer, 0.76, y, 0.025, 0.025);
					
					y = y - 0.03;
				end;
			end;
		end;
		
		if self.clientNeedsMoneyPermissionWarning > 0 then
			g_currentMission:renderText(0.05, 0.04, 0.03, self.clientNeedsMoneyWarning);
		end;
		
		setTextColor(1, 1, 1, 1);
	end;
end;

function ExternalAccount:enterMenu()	
	g_currentMission.externalAccount.isHUDActive = true;
	InputBinding.setShowMouseCursor(true);
	g_gui.currentGui = self;
	self.fileFound = true;
end;

function ExternalAccount:leaveMenu()
	g_currentMission.externalAccount.isHUDActive = false;
	InputBinding.setShowMouseCursor(false);
	g_gui.currentGui = nil;
end;

function ExternalAccount:moneyReceived(userId, money)
	if userId == g_currentMission.playerUserId then
		self:addMoneyToExternalAccount(money);
	end;
end;

function ExternalAccount:clientMoneyAcount(userId, money)
	for a=1, table.getn(g_currentMission.users) do
		if g_currentMission.users[a].userId == userId then
			g_currentMission.users[a].money = g_currentMission.users[a].money + money;
		end;
	end;
end;

addModEventListener(ExternalAccount);